﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class AutoType : MonoBehaviour {

	private string message;

	private Text myText;

	public float letterPause = 0.2f;
	public float dramaticPause = 0.8f;
	public AudioSource source;
	public AudioClip sound;
	public Text nextText;

	public ShowPanels showPanels;

	// Use this for initialization
	void Start () {
		myText = GetComponent<Text> ();
		message = myText.text;
		myText.text = "";
		StartCoroutine(TypeText ());
	}

	void Update()
	{
		if (Input.GetKeyDown (KeyCode.Escape)) {
			showPanels.HideStoryPanel ();
			SceneManager.LoadScene (1);
			showPanels.ShowMenu ();
		}
	}

	IEnumerator TypeText () {
		foreach (char letter in message.ToCharArray()) {
			float pauseTime = dramaticPause;
			if (letter != '^') {
				myText.text += letter;
				pauseTime = letterPause;
				if (sound)
					source.PlayOneShot (sound);
			}
			yield return 0;
			yield return new WaitForSeconds (pauseTime);
		}
		StartCoroutine (NextText ());
	}

	IEnumerator NextText()
	{
		yield return new WaitForSeconds(2f);

		if (nextText) {
			nextText.gameObject.SetActive (true);
			gameObject.SetActive (false);
		} else {
			//Load the selected scene, by scene index number in build settings
			showPanels.HideStoryPanel ();
			SceneManager.LoadScene (1);
			showPanels.ShowMenu ();
		}
	}
}