﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class SelectChar : MonoBehaviour {

	private PLAYER_SELECT playerSelectState = PLAYER_SELECT.PLAYER_1_SELECT;

	private int numberOfPlayers; // contagem de quantos jogaroes entraram no jogo

	private KeyCode player1Control;
	private KeyCode player2Control;
	private KeyCode player3Control;
	private KeyCode player4Control;
	private KeyCode player5Control;
	private KeyCode player6Control;
	private KeyCode player7Control;
	private KeyCode player8Control;

	public ShowPanels showPanels;

	public Text InstructionsLabel;

	public GameObject SelectionSprite1;
	public GameObject SelectionSprite2;
	public GameObject SelectionSprite3;
	public GameObject SelectionSprite4;
	public GameObject SelectionSprite5;
	public GameObject SelectionSprite6;
	public GameObject SelectionSprite7;
	public GameObject SelectionSprite8;

	public Text SelectedKey1Label;
	public Text SelectedKey2Label;
	public Text SelectedKey3Label;
	public Text SelectedKey4Label;
	public Text SelectedKey5Label;
	public Text SelectedKey6Label;
	public Text SelectedKey7Label;
	public Text SelectedKey8Label;

	// Use this for initialization
	void Start () {
		InstructionsLabel.text = "Waiting for players";

		SelectedKey1Label.text = "Press any Key";
		SelectedKey2Label.text = "Wait";
		SelectedKey3Label.text = "Wait";
		SelectedKey4Label.text = "Wait";
		SelectedKey5Label.text = "Wait";
		SelectedKey6Label.text = "Wait";
		SelectedKey7Label.text = "Wait";
		SelectedKey8Label.text = "Wait";

		SelectionSprite1.SetActive (true);
		SelectionSprite2.SetActive (false);
		SelectionSprite3.SetActive (false);
		SelectionSprite4.SetActive (false);
		SelectionSprite5.SetActive (false);
		SelectionSprite6.SetActive (false);
		SelectionSprite7.SetActive (false);
		SelectionSprite8.SetActive (false);

		numberOfPlayers = 0;

		playerSelectState = PLAYER_SELECT.PLAYER_1_SELECT;
	}
	
	// Update is called once per frame
	void Update ()
	{
		switch (playerSelectState) 
		{
			case PLAYER_SELECT.PLAYER_1_SELECT:
				player1Control = CheckKey ();
				if (player1Control != KeyCode.Backspace) {
					PlayerPrefs.SetInt ("Player1Control", (int)player1Control);
					numberOfPlayers += 1;

					SelectedKey1Label.text = player1Control.ToString();
					SelectedKey2Label.text = "Press any Key";
					SelectionSprite1.SetActive (false);
					SelectionSprite2.SetActive (true);
					InstructionsLabel.text = "Waiting for more players";

					playerSelectState = PLAYER_SELECT.PLAYER_2_SELECT;
				}
				break;

			case PLAYER_SELECT.PLAYER_2_SELECT:
				player2Control = CheckKey ();
				if (player2Control != KeyCode.Backspace 
					&& player2Control != player1Control) {
					PlayerPrefs.SetInt ("Player2Control", (int)player2Control);
					numberOfPlayers += 1;

					SelectedKey2Label.text = player2Control.ToString();
					SelectedKey3Label.text = "Press any Key";
					SelectionSprite2.SetActive (false);
					SelectionSprite3.SetActive (true);
					InstructionsLabel.text = "Waiting for more players\nor press Space to start";

					playerSelectState = PLAYER_SELECT.PLAYER_3_SELECT;
				}
				break;

			case PLAYER_SELECT.PLAYER_3_SELECT:
				player3Control = CheckKey ();
				if (player3Control != KeyCode.Backspace
					&& player3Control != player1Control
					&& player3Control != player2Control) {
					PlayerPrefs.SetInt ("Player3Control", (int)player3Control);
					numberOfPlayers += 1;

					SelectedKey3Label.text = player3Control.ToString();
					SelectedKey4Label.text = "Press any Key";
					SelectionSprite3.SetActive (false);
					SelectionSprite4.SetActive (true);

					playerSelectState = PLAYER_SELECT.PLAYER_4_SELECT;
				}

				CharacterSelectionDone ();
				break;

			case PLAYER_SELECT.PLAYER_4_SELECT:
				player4Control = CheckKey ();
				if (player4Control != KeyCode.Backspace 
					&& player4Control != player1Control 
					&& player4Control != player2Control 
					&& player4Control != player3Control) {
					PlayerPrefs.SetInt ("Player4Control", (int)player4Control);
					numberOfPlayers += 1;

					SelectedKey4Label.text = player4Control.ToString();
					SelectedKey5Label.text = "Press any Key";
					SelectionSprite4.SetActive (false);
					SelectionSprite5.SetActive (true);

					playerSelectState = PLAYER_SELECT.PLAYER_5_SELECT;
				}

				CharacterSelectionDone ();
				break;

			case PLAYER_SELECT.PLAYER_5_SELECT:
				player5Control = CheckKey ();
				if (player5Control != KeyCode.Backspace 
					&& player5Control != player1Control
					&& player5Control != player2Control
					&& player5Control != player3Control
					&& player5Control != player4Control) {
					PlayerPrefs.SetInt ("Player5Control", (int)player5Control);
					numberOfPlayers += 1;

					SelectedKey5Label.text = player5Control.ToString();
					SelectedKey6Label.text = "Press any Key";
					SelectionSprite5.SetActive (false);
					SelectionSprite6.SetActive (true);

					playerSelectState = PLAYER_SELECT.PLAYER_6_SELECT;
				}

				CharacterSelectionDone ();
				break;

			case PLAYER_SELECT.PLAYER_6_SELECT:
				player6Control = CheckKey ();
				if (player6Control != KeyCode.Backspace 
					&& player6Control != player1Control
					&& player6Control != player2Control
					&& player6Control != player3Control
					&& player6Control != player4Control
					&& player6Control != player5Control) {
					PlayerPrefs.SetInt ("Player6Control", (int)player6Control);
					numberOfPlayers += 1;

					SelectedKey6Label.text = player6Control.ToString();
					SelectedKey7Label.text = "Press any Key";
					SelectionSprite6.SetActive (false);
					SelectionSprite7.SetActive (true);

					playerSelectState = PLAYER_SELECT.PLAYER_7_SELECT;
				}

				CharacterSelectionDone ();
				break;

			case PLAYER_SELECT.PLAYER_7_SELECT:
				player7Control = CheckKey ();
				if (player7Control != KeyCode.Backspace 
					&& player7Control != player1Control
					&& player7Control != player2Control
					&& player7Control != player3Control
					&& player7Control != player4Control
					&& player7Control != player5Control
					&& player7Control != player6Control) {
					PlayerPrefs.SetInt ("Player7Control", (int)player7Control);
					numberOfPlayers += 1;

					SelectedKey7Label.text = player7Control.ToString();
					SelectedKey8Label.text = "Press any Key";
					SelectionSprite7.SetActive (false);
					SelectionSprite8.SetActive (true);

					playerSelectState = PLAYER_SELECT.PLAYER_8_SELECT;
				}

				CharacterSelectionDone ();
				break;

			case PLAYER_SELECT.PLAYER_8_SELECT:
				player8Control = CheckKey ();
				if (player8Control != KeyCode.Backspace 
					&& player8Control != player1Control
					&& player8Control != player2Control
					&& player8Control != player3Control
					&& player8Control != player4Control
					&& player8Control != player5Control
					&& player8Control != player6Control
					&& player8Control != player7Control) {
					PlayerPrefs.SetInt ("Player8Control", (int)player8Control);
					numberOfPlayers += 1;

					SelectedKey8Label.text = player8Control.ToString();
					SelectionSprite8.SetActive (false);

					StartCoroutine(SavePrefabs ());
				}

				CharacterSelectionDone ();
				break;
		}
	}

	private KeyCode CheckKey()
	{
		if (Input.GetKeyDown(KeyCode.A)) return KeyCode.A;
		if (Input.GetKeyDown(KeyCode.B)) return KeyCode.B;
		if (Input.GetKeyDown(KeyCode.C)) return KeyCode.C;
		if (Input.GetKeyDown(KeyCode.D)) return KeyCode.D;
		if (Input.GetKeyDown(KeyCode.E)) return KeyCode.E;
		if (Input.GetKeyDown(KeyCode.F)) return KeyCode.F;
		if (Input.GetKeyDown(KeyCode.G)) return KeyCode.G;
		if (Input.GetKeyDown(KeyCode.H)) return KeyCode.H;
		if (Input.GetKeyDown(KeyCode.I)) return KeyCode.I;
		if (Input.GetKeyDown(KeyCode.J)) return KeyCode.J;
		if (Input.GetKeyDown(KeyCode.K)) return KeyCode.K;
		if (Input.GetKeyDown(KeyCode.L)) return KeyCode.L;
		if (Input.GetKeyDown(KeyCode.M)) return KeyCode.M;
		if (Input.GetKeyDown(KeyCode.N)) return KeyCode.N;
		if (Input.GetKeyDown(KeyCode.O)) return KeyCode.O;
		if (Input.GetKeyDown(KeyCode.P)) return KeyCode.P;
		if (Input.GetKeyDown(KeyCode.Q)) return KeyCode.Q;
		if (Input.GetKeyDown(KeyCode.R)) return KeyCode.R;
		if (Input.GetKeyDown(KeyCode.S)) return KeyCode.S;
		if (Input.GetKeyDown(KeyCode.T)) return KeyCode.T;
		if (Input.GetKeyDown(KeyCode.U)) return KeyCode.U;
		if (Input.GetKeyDown(KeyCode.V)) return KeyCode.V;
		if (Input.GetKeyDown(KeyCode.W)) return KeyCode.W;
		if (Input.GetKeyDown(KeyCode.X)) return KeyCode.X;
		if (Input.GetKeyDown(KeyCode.Y)) return KeyCode.Y;
		if (Input.GetKeyDown(KeyCode.Z)) return KeyCode.Z;

		if (Input.GetKeyDown(KeyCode.Alpha0)) return KeyCode.Alpha0;
		if (Input.GetKeyDown(KeyCode.Alpha1)) return KeyCode.Alpha1;
		if (Input.GetKeyDown(KeyCode.Alpha2)) return KeyCode.Alpha2;
		if (Input.GetKeyDown(KeyCode.Alpha3)) return KeyCode.Alpha3;
		if (Input.GetKeyDown(KeyCode.Alpha4)) return KeyCode.Alpha4;
		if (Input.GetKeyDown(KeyCode.Alpha5)) return KeyCode.Alpha5;
		if (Input.GetKeyDown(KeyCode.Alpha6)) return KeyCode.Alpha6;
		if (Input.GetKeyDown(KeyCode.Alpha7)) return KeyCode.Alpha7;
		if (Input.GetKeyDown(KeyCode.Alpha8)) return KeyCode.Alpha8;
		if (Input.GetKeyDown(KeyCode.Alpha9)) return KeyCode.Alpha9;

		if (Input.GetKeyDown(KeyCode.Keypad0)) return KeyCode.Keypad0;
		if (Input.GetKeyDown(KeyCode.Keypad1)) return KeyCode.Keypad1;
		if (Input.GetKeyDown(KeyCode.Keypad2)) return KeyCode.Keypad2;
		if (Input.GetKeyDown(KeyCode.Keypad3)) return KeyCode.Keypad3;
		if (Input.GetKeyDown(KeyCode.Keypad4)) return KeyCode.Keypad4;
		if (Input.GetKeyDown(KeyCode.Keypad5)) return KeyCode.Keypad5;
		if (Input.GetKeyDown(KeyCode.Keypad6)) return KeyCode.Keypad6;
		if (Input.GetKeyDown(KeyCode.Keypad7)) return KeyCode.Keypad7;
		if (Input.GetKeyDown(KeyCode.Keypad8)) return KeyCode.Keypad8;
		if (Input.GetKeyDown(KeyCode.Keypad9)) return KeyCode.Keypad9;

		if (Input.GetKeyDown(KeyCode.Mouse0)) return KeyCode.Mouse0;
		if (Input.GetKeyDown(KeyCode.Mouse1)) return KeyCode.Mouse1;
		if (Input.GetKeyDown(KeyCode.Mouse2)) return KeyCode.Mouse2;
		if (Input.GetKeyDown(KeyCode.Mouse3)) return KeyCode.Mouse3;
		if (Input.GetKeyDown(KeyCode.Mouse4)) return KeyCode.Mouse4;
		if (Input.GetKeyDown(KeyCode.Mouse5)) return KeyCode.Mouse5;
		if (Input.GetKeyDown(KeyCode.Mouse6)) return KeyCode.Mouse6;

		if (Input.GetKeyDown(KeyCode.Joystick1Button0)) return KeyCode.Joystick1Button0;
		if (Input.GetKeyDown(KeyCode.Joystick1Button1)) return KeyCode.Joystick1Button1;
		if (Input.GetKeyDown(KeyCode.Joystick1Button2)) return KeyCode.Joystick1Button2;
		if (Input.GetKeyDown(KeyCode.Joystick1Button3)) return KeyCode.Joystick1Button3;
		if (Input.GetKeyDown(KeyCode.Joystick1Button4)) return KeyCode.Joystick1Button4;
		if (Input.GetKeyDown(KeyCode.Joystick1Button5)) return KeyCode.Joystick1Button5;
		if (Input.GetKeyDown(KeyCode.Joystick1Button6)) return KeyCode.Joystick1Button6;
		if (Input.GetKeyDown(KeyCode.Joystick1Button7)) return KeyCode.Joystick1Button7;
		if (Input.GetKeyDown(KeyCode.Joystick1Button8)) return KeyCode.Joystick1Button8;
		if (Input.GetKeyDown(KeyCode.Joystick1Button9)) return KeyCode.Joystick1Button9;

		if (Input.GetKeyDown(KeyCode.Joystick2Button0)) return KeyCode.Joystick2Button0;
		if (Input.GetKeyDown(KeyCode.Joystick2Button1)) return KeyCode.Joystick2Button1;
		if (Input.GetKeyDown(KeyCode.Joystick2Button2)) return KeyCode.Joystick2Button2;
		if (Input.GetKeyDown(KeyCode.Joystick2Button3)) return KeyCode.Joystick2Button3;
		if (Input.GetKeyDown(KeyCode.Joystick2Button4)) return KeyCode.Joystick2Button4;
		if (Input.GetKeyDown(KeyCode.Joystick2Button5)) return KeyCode.Joystick2Button5;
		if (Input.GetKeyDown(KeyCode.Joystick2Button6)) return KeyCode.Joystick2Button6;
		if (Input.GetKeyDown(KeyCode.Joystick2Button7)) return KeyCode.Joystick2Button7;
		if (Input.GetKeyDown(KeyCode.Joystick2Button8)) return KeyCode.Joystick2Button8;
		if (Input.GetKeyDown(KeyCode.Joystick2Button9)) return KeyCode.Joystick2Button9;

		if (Input.GetKeyDown(KeyCode.Joystick3Button0)) return KeyCode.Joystick3Button0;
		if (Input.GetKeyDown(KeyCode.Joystick3Button1)) return KeyCode.Joystick3Button1;
		if (Input.GetKeyDown(KeyCode.Joystick3Button2)) return KeyCode.Joystick3Button2;
		if (Input.GetKeyDown(KeyCode.Joystick3Button3)) return KeyCode.Joystick3Button3;
		if (Input.GetKeyDown(KeyCode.Joystick3Button4)) return KeyCode.Joystick3Button4;
		if (Input.GetKeyDown(KeyCode.Joystick3Button5)) return KeyCode.Joystick3Button5;
		if (Input.GetKeyDown(KeyCode.Joystick3Button6)) return KeyCode.Joystick3Button6;
		if (Input.GetKeyDown(KeyCode.Joystick3Button7)) return KeyCode.Joystick3Button7;
		if (Input.GetKeyDown(KeyCode.Joystick3Button8)) return KeyCode.Joystick3Button8;
		if (Input.GetKeyDown(KeyCode.Joystick3Button9)) return KeyCode.Joystick3Button9;

		if (Input.GetKeyDown(KeyCode.Joystick4Button0)) return KeyCode.Joystick4Button0;
		if (Input.GetKeyDown(KeyCode.Joystick4Button1)) return KeyCode.Joystick4Button1;
		if (Input.GetKeyDown(KeyCode.Joystick4Button2)) return KeyCode.Joystick4Button2;
		if (Input.GetKeyDown(KeyCode.Joystick4Button3)) return KeyCode.Joystick4Button3;
		if (Input.GetKeyDown(KeyCode.Joystick4Button4)) return KeyCode.Joystick4Button4;
		if (Input.GetKeyDown(KeyCode.Joystick4Button5)) return KeyCode.Joystick4Button5;
		if (Input.GetKeyDown(KeyCode.Joystick4Button6)) return KeyCode.Joystick4Button6;
		if (Input.GetKeyDown(KeyCode.Joystick4Button7)) return KeyCode.Joystick4Button7;
		if (Input.GetKeyDown(KeyCode.Joystick4Button8)) return KeyCode.Joystick4Button8;
		if (Input.GetKeyDown(KeyCode.Joystick4Button9)) return KeyCode.Joystick4Button9;

		return KeyCode.Backspace;
	}

	void CharacterSelectionDone(){
		if (Input.GetKeyDown(KeyCode.Space)) { // cancelando escolha de outros personagens e indo pra o jogo
			//muda de tela e vai pro jogo

			SaveAndStart ();
		}
	}

	IEnumerator SavePrefabs(){

		yield return new WaitForSeconds (2);

		SaveAndStart ();
	}

	private void SaveAndStart()
	{
		PlayerPrefs.SetInt ("numberOfPlayers", numberOfPlayers);
		showPanels.HideSelectCharPanel ();
		showPanels.ShowPrepPanel ();
	}

	public void Restart () {
		Start ();

		Time.timeScale = 1;
	}
}
