﻿using UnityEngine;
using System.Collections;

public class ShowPanels : MonoBehaviour {

	public GameObject splashPanel;							//Store a reference to the Game Object OptionsPanel
	public GameObject storyPanel;
	public GameObject creditsPanel;
	public GameObject optionsPanel;							//Store a reference to the Game Object OptionsPanel 
	public GameObject optionsTint;							//Store a reference to the Game Object OptionsTint 
	public GameObject menuPanel;							//Store a reference to the Game Object MenuPanel
	public GameObject prepPanel;
	public GameObject selectCharPanel;
	public GameObject countDownPanel;
	public GameObject pausePanel;							//Store a reference to the Game Object PausePanel
	public GameObject endGame;

	public void ShowSplashPanel()
	{
		splashPanel.SetActive (true);
	}

	public void HideSplashPanel()
	{
		splashPanel.SetActive (false);
	}

	public void ShowStoryPanel()
	{
		storyPanel.SetActive (true);
	}

	public void HideStoryPanel()
	{
		storyPanel.SetActive (false);
	}

	public void ShowCreditsPanel(){
		creditsPanel.SetActive(true);
		optionsTint.SetActive(true);
	}

	public void HideCreditsPanel(){
		creditsPanel.SetActive(false);
		optionsTint.SetActive(false);
	}

	public void ShowPrepPanel()
	{
		prepPanel.SetActive (true);
		prepPanel.GetComponent<PrepScreen> ().Restart ();
	}

	public void HidePrepPanel()
	{
		prepPanel.SetActive (false);
	}

	public void ShowSelectCharPanel(){
		selectCharPanel.SetActive (true);
	}

	public void HideSelectCharPanel(){
		selectCharPanel.SetActive (false);
	}

	//Call this function to activate and display the Options panel during the main menu
	public void ShowOptionsPanel()
	{
		optionsPanel.SetActive(true);
		optionsTint.SetActive(true);
	}

	//Call this function to deactivate and hide the Options panel during the main menu
	public void HideOptionsPanel()
	{
		optionsPanel.SetActive(false);
		optionsTint.SetActive(false);
	}

	//Call this function to activate and display the main menu panel during the main menu
	public void ShowMenu()
	{
		menuPanel.SetActive (true);
	}

	//Call this function to deactivate and hide the main menu panel during the main menu
	public void HideMenu()
	{
		menuPanel.SetActive (false);
	}

	public void ShowCountDownPanel()
	{
		countDownPanel.SetActive (true);
	}

	public void HideCountDownPanel()
	{
		countDownPanel.SetActive (false);
	}

	//Call this function to activate and display the Pause panel during game play
	public void ShowPausePanel()
	{
		pausePanel.SetActive (true);
		optionsTint.SetActive(true);
	}

	//Call this function to deactivate and hide the Pause panel during game play
	public void HidePausePanel()
	{
		pausePanel.SetActive (false);
		optionsTint.SetActive(false);
	}

	public void ShowEndGame()
	{
		endGame.SetActive (true);
	}

	public void HideEndGame()
	{
		endGame.SetActive (false);
	}
}
