﻿using System.Collections;
using UnityEngine;

public class HeadCollider : MonoBehaviour {

	public PlayerController playerController { get; set;}

	[SerializeField] private Transform[] headsDetector = new Transform[]{};

	[SerializeField] private float rayDistance = 0;

	private PlayerMove myPlayerMove;

	void Awake(){
		myPlayerMove = GetComponent<PlayerMove> ();
	}

	void Update(){
		
		foreach (Transform head in headsDetector) {

			Vector2 headPos = new Vector2 (head.position.x, head.position.y);

			Ray2D ray = new Ray2D (headPos, Vector2.up);

			RaycastHit2D hit = Physics2D.Raycast(headPos, Vector2.up, rayDistance);

			if (hit.collider != null) {
				if (hit.collider.gameObject.tag == "Player") {

					playerController.Damage (); // removendo life do player controller

					Destroy (gameObject);

					// aplicando impulso no inimigo que o matou
					if (hit.collider.gameObject.GetComponent<Rigidbody2D> ()) {
						Rigidbody2D enemyBody = hit.collider.gameObject.GetComponent<Rigidbody2D> ();
						enemyBody.Sleep ();
						enemyBody.AddForce (Vector2.up * myPlayerMove.jumpForce); // aplicar o salto
					}

					return;
				}
			}


			Debug.DrawLine (headPos, headPos + (ray.direction * rayDistance), Color.cyan);
		}
			
	}

}
