﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class PlayerController : MonoBehaviour {

	public PlayersList Player;

	private AudioSource audioSource;
	public AudioClip dieSound;

	public ParticleSystem deathParticle;

	[SerializeField] private int Lifes = 3;

	[SerializeField] private Color characterColor = new Color();

	[SerializeField] private GameObject characterPrefab;

	public Text lifeLabel;

	private Transform savedChar;

	void Awake()
	{
		audioSource = GameObject.Find ("UI").GetComponent<AudioSource> ();
		lifeLabel.transform.position = new Vector2 (transform.position.x, transform.position.y);
	}

	public void EnableLable()
	{
		lifeLabel.enabled = true;
	}

	public void InstantiateCharacter(){
		
		lifeLabel.enabled = false;

		if (Lifes > 0) {
			PlayerSelect newCharacter = Instantiate (characterPrefab, transform.position, Quaternion.identity)
				.GetComponent<PlayerSelect>(); // criando personagem e pegando seu select ao mesmo tempo

			newCharacter.Player = Player; // dando a selecao do personagem criado com base neste objeto

			//newCharacter.GetComponent<SpriteRenderer> ().color = characterColor;

			newCharacter.GetComponent<HeadCollider> ().playerController = this; // falando que este e o conroller do personagem
			newCharacter.GetComponent<PlayerMove> ().playerController = this; // falando que este e o conroller do personagem
			newCharacter.GetComponent<PlayerMove> ().waveColor = characterColor;

			savedChar = newCharacter.transform;
		}
	}

	public void Damage(){ // funcao para remover vida, esperar e criar personagem
		Lifes -= 1; 

		lifeLabel.enabled = true;
		lifeLabel.text = "" + Lifes;

		audioSource.PlayOneShot (dieSound);

		UnityEngine.ParticleSystem.MainModule auxMain = deathParticle.main;
		auxMain.startColor = characterColor;
		Instantiate (deathParticle, savedChar.position, Quaternion.identity);

		Invoke ("InstantiateCharacter", 2f); // depois que morrer, esperar dois segunos e criar um novo personagem
	}

	public bool isDead()
	{
		if (Lifes <= 0) return true;
		return false;
	}

}
