﻿using UnityEngine; 
using System.Collections;

public class ShakeCamera : MonoBehaviour { 

	public static ShakeCamera Instance { get; set;} // para que qualquer classe encontre sem buscar componente

	public bool shakePosition;
	public bool shakeRotation;

	public float shakeIntensity = 0.5f; 
	public float shakeDecay = 0.02f;

//	private Vector3 OriginalPos;
	private Quaternion OriginalRot;

	private bool isShakeRunning = false;

	void Awake(){
		Instance = this;
	}


	public void DoShake()
	{


//		OriginalPos = transform.position;
		OriginalRot = transform.rotation;

		StartCoroutine ("ProcessShake");
	}

	IEnumerator ProcessShake()
	{
		if (!isShakeRunning) {
			isShakeRunning = true;
			float currentShakeIntensity = shakeIntensity;

			while (currentShakeIntensity > 0) {
				if (shakePosition) {
					transform.position = new Vector3(Random.insideUnitSphere.x * currentShakeIntensity, transform.position.y ,transform.position.z);
					// just change the float values of the Vector3 Component to Random.insideUnitSphere.x/y/z where you see fit.
				}
				if (shakeRotation) {
					transform.rotation = new Quaternion (OriginalRot.x + Random.Range (-currentShakeIntensity, currentShakeIntensity) * .2f,
						OriginalRot.y + Random.Range (-currentShakeIntensity, currentShakeIntensity) * .2f,
						OriginalRot.z + Random.Range (-currentShakeIntensity, currentShakeIntensity) * .2f,
						OriginalRot.w + Random.Range (-currentShakeIntensity, currentShakeIntensity) * .2f);
				}
				currentShakeIntensity -= shakeDecay;
				yield return null;
			}

			isShakeRunning = false;
		}
	}
}